import DataTable from 'datatables.net';
import {createModalFromUri} from '@digicomp/modal-stack';

DataTable.ext.buttons.actionModal = {
    action: async function ( e, dt, node, config ) {
        const modal = await createModalFromUri(config.uri);
        modal.element.addEventListener('modal-stack-form-submit-success', () => {
            dt.draw();
        });
        modal.open();
    },
};

DataTable.ext.buttons.actionModalSelected = {
    extend: 'selected',
    action: async function ( e, dt, node, config ) {
        const {
            rowIdentityProperty = '__identity',
            uriIdentityPlaceholder = 'SUBJECT'
        } = config;
        const identity = dt.rows({selected: true}).data()[0][rowIdentityProperty];

        const modal = await createModalFromUri(config.uri.replace(uriIdentityPlaceholder, identity));
        modal.element.addEventListener('modal-stack-form-submit-success', () => {
            dt.draw();
        });
        modal.open();
    },
};
